- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# CoinSearchTreeBase Class Reference

`#include <CoinSearchTree.hpp>`

Inheritance diagram for CoinSearchTreeBase:

[legend]
List of all members.

## Public Member Functions
virtual | ~CoinSearchTreeBase ()
virtual const char * | compName () const =0
const std::vector< CoinTreeSiblings * > & | getCandidates () const
bool | empty () const
int | size () const
int | numInserted () const
CoinTreeNode * | top () const
void | pop ()
| pop will advance the `next` pointer among the siblings on the top and then moves the top to its correct position.
void | push (int numNodes, CoinTreeNode **nodes, const bool incrInserted=true)
void | push (const CoinTreeSiblings &sib, const bool incrInserted=true)
## Protected Member Functions
| CoinSearchTreeBase ()
virtual void | realpop ()=0
virtual void | realpush (CoinTreeSiblings *s)=0
virtual void | fixTop ()=0
## Protected Attributes
std::vector< CoinTreeSiblings * > | candidateList_
int | numInserted_
int | size_
## Private Member Functions
| CoinSearchTreeBase (const CoinSearchTreeBase &)
CoinSearchTreeBase & | operator= (const CoinSearchTreeBase &)

## Detailed Description

Definition at line 210 of file CoinSearchTree.hpp.

## Constructor & Destructor Documentation

CoinSearchTreeBase::CoinSearchTreeBase | ( | const CoinSearchTreeBase & |  | ) | `[private]`

CoinSearchTreeBase::CoinSearchTreeBase | ( |  | ) | `[inline, protected]`

Definition at line 222 of file CoinSearchTree.hpp.

virtual CoinSearchTreeBase::~CoinSearchTreeBase | ( |  | ) | `[inline, virtual]`

Definition at line 229 of file CoinSearchTree.hpp.

## Member Function Documentation

CoinSearchTreeBase& CoinSearchTreeBase::operator= | ( | const CoinSearchTreeBase & |  | ) | `[private]`

virtual void CoinSearchTreeBase::realpop | ( |  | ) | `[protected, pure virtual]`

Implemented in CoinSearchTree< Comp >.

Referenced by pop().

virtual void CoinSearchTreeBase::realpush | ( | CoinTreeSiblings * | s | ) | `[protected, pure virtual]`

Implemented in CoinSearchTree< Comp >.

Referenced by push().

virtual void CoinSearchTreeBase::fixTop | ( |  | ) | `[protected, pure virtual]`

Implemented in CoinSearchTree< Comp >.

Referenced by pop().

virtual const char* CoinSearchTreeBase::compName | ( |  | ) | const`[pure virtual]`

Implemented in CoinSearchTree< Comp >.

const std::vector<CoinTreeSiblings*>& CoinSearchTreeBase::getCandidates | ( |  | ) | const`[inline]`

Definition at line 232 of file CoinSearchTree.hpp.

References candidateList_.

Referenced by CoinSearchTree< Comp >::CoinSearchTree().

bool CoinSearchTreeBase::empty | ( |  | ) | const`[inline]`

Definition at line 235 of file CoinSearchTree.hpp.

References candidateList_.

Referenced by CoinSearchTreeManager::empty().

int CoinSearchTreeBase::size | ( |  | ) | const`[inline]`

Definition at line 236 of file CoinSearchTree.hpp.

References size_.

Referenced by CoinSearchTree< Comp >::CoinSearchTree(), CoinSearchTree< Comp >::fixTop(), and CoinSearchTreeManager::size().

int CoinSearchTreeBase::numInserted | ( |  | ) | const`[inline]`

Definition at line 237 of file CoinSearchTree.hpp.

References numInserted_.

Referenced by CoinSearchTree< Comp >::CoinSearchTree(), and CoinSearchTreeManager::numInserted().

CoinTreeNode* CoinSearchTreeBase::top | ( |  | ) | const`[inline]`

Definition at line 238 of file CoinSearchTree.hpp.

References candidateList_, and size_.

Referenced by CoinSearchTreeManager::bestQuality(), CoinSearchTreeManager::bestQualityCandidate(), and CoinSearchTreeManager::top().

void CoinSearchTreeBase::pop | ( |  | ) | `[inline]`

pop will advance the `next` pointer among the siblings on the top and then moves the top to its correct position.

realpop is the method that actually removes the element from the heap

Definition at line 252 of file CoinSearchTree.hpp.

References CoinTreeSiblings::advanceNode(), candidateList_, fixTop(), realpop(), and size_.

Referenced by CoinSearchTreeManager::pop().

void CoinSearchTreeBase::push | ( | int | numNodes,
|  | CoinTreeNode ** | nodes,
|  | const bool | incrInserted = `true` |
| ) |  |  | `[inline]`

Definition at line 262 of file CoinSearchTree.hpp.

References numInserted_, realpush(), and size_.

Referenced by CoinSearchTreeManager::push().

void CoinSearchTreeBase::push | ( | const CoinTreeSiblings & | sib,
|  | const bool | incrInserted = `true` |
| ) |  |  | `[inline]`

Definition at line 271 of file CoinSearchTree.hpp.

References numInserted_, CoinTreeSiblings::printPref(), realpush(), CoinTreeSiblings::size(), size_, and CoinTreeSiblings::toProcess().

## Member Data Documentation

std::vector<CoinTreeSiblings*> CoinSearchTreeBase::candidateList_`[protected]`

Definition at line 217 of file CoinSearchTree.hpp.

Referenced by CoinSearchTree< Comp >::CoinSearchTree(), empty(), CoinSearchTree< Comp >::fixTop(), getCandidates(), pop(), CoinSearchTree< Comp >::realpop(), CoinSearchTree< Comp >::realpush(), and top().

int CoinSearchTreeBase::numInserted_`[protected]`

Definition at line 218 of file CoinSearchTree.hpp.

Referenced by CoinSearchTree< Comp >::CoinSearchTree(), numInserted(), and push().

int CoinSearchTreeBase::size_`[protected]`

Definition at line 219 of file CoinSearchTree.hpp.

Referenced by CoinSearchTree< Comp >::CoinSearchTree(), pop(), push(), size(), and top().

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Bcps-0.91.0/CoinUtils/src/CoinSearchTree.hpp